---
title: GlobalEventHandlers.oninvalid
slug: Web/API/GlobalEventHandlers/oninvalid
tags:
  - API
  - Event Handler
  - GlobalEventHandlers
  - Property
  - Reference
---
<div>{{ ApiRef("HTML DOM") }}</div>

<p>The <code><strong>oninvalid</strong></code> property of the {{domxref("GlobalEventHandlers")}} mixin is an {{domxref("EventHandler")}} that processes {{event("invalid")}} events.</p>

<p>The <code>invalid</code> event fires when a submittable element has been checked and doesn't satisfy its constraints. The validity of submittable elements is checked before submitting their owner form, or after the <code><a href="/en-US/docs/Learn/HTML/Forms/Form_validation">checkValidity()</a></code> method of the element or its owner form is called.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>target</em>.oninvalid = <em>functionRef</em>;
var <em>functionRef</em> = <em>target</em>.oninvalid;
</pre>

<h3 id="Value">Value</h3>

<p><code>functionRef</code> is a function name or a <a href="/en-US/docs/Web/JavaScript/Reference/Operators/function">function expression</a>. The function receives a {{domxref("Event")}} object as its sole argument.</p>

<h2 id="Example">Example</h2>

<p>This example demonstrates <code>oninvalid</code> and {{domxref("GlobalEventHandlers.onsubmit", "onsubmit")}} event handlers on a form.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;form id="form"&gt;
  &lt;p id="error" hidden&gt;Please fill out all fields.&lt;/p&gt;

  &lt;label for="city"&gt;City&lt;/label&gt;
  &lt;input type="text" id="city" required&gt;

  &lt;button type="submit"&gt;Submit&lt;/button&gt;
&lt;/form&gt;
&lt;p id="thanks" hidden&gt;Your data has been received. Thanks!&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">const form = document.getElementById('form');
const error = document.getElementById('error');
const city = document.getElementById('city');
const thanks = document.getElementById('thanks');

city.oninvalid = invalid;
form.onsubmit = submit;

function invalid(event) {
  error.removeAttribute('hidden');
}

function submit(event) {
  form.setAttribute('hidden', '');
  thanks.removeAttribute('hidden');

  // For this example, don't actually submit the form
  event.preventDefault();
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG','#handler-oninvalid','oninvalid')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.GlobalEventHandlers.oninvalid")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{event("invalid")}} event</li>
 <li><a href="/en-US/docs/Web/Guide/Events/Event_handlers" title="/en-US/docs/Web/Guide/DOM/Events/Event_handlers">DOM on-event handlers</a></li>
</ul>
